package org.poopki.duckdns.user_db;

import org.bukkit.event.Listener;
import org.bukkit.plugin.java.JavaPlugin;
import org.poopki.duckdns.user_db.DB.*;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;


public final class User_DB extends JavaPlugin implements Listener {

    AccountArray m_AccountArrayInstance = new AccountArray();
    UserInfoArray m_InfoArrayInstance = new UserInfoArray(); // UserInfo저장하는 Array instance 생성


    DBUpdate Database_backup = new DBUpdate(m_InfoArrayInstance, m_AccountArrayInstance);
    @Override
    public void onEnable() {
        // Plugin startup logic
        try {
            Database_backup.InitDB();
            Database_backup.LoadDB();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
        getCommand("계좌").setExecutor(new AccountEventHandler(m_AccountArrayInstance));
        getServer().getPluginManager().registerEvents(new UserJoin(m_InfoArrayInstance, m_AccountArrayInstance),this);

    }

    @Override
    public void onDisable() {
        // Plugin shutdown logic
        try{
            Database_backup.UpdateDB();
        } catch (SQLException e){
            throw new RuntimeException(e);
        }
    }
}
